/*--------------------------------------------------------------------*/
/*                        CS/2 PTF Installation                       */
/*                                                                    */
/*         (C) Copyright IBM Corp. 1996  All rights reserved.         */
/*--------------------------------------------------------------------*/
ptfnum = "UQ05603"
prereq = "       "
prerq1 = "UN78045"
prerq2 = "UN87209"

/* NOTE: install uses pkunzip.exe, sysedit.exe and 'ptfnum'.lst file,*/
/*       which are shipped with the PTF.  'ptfnum'.lst contains the   */
/*       correlation between the file name, path, and install options */
VersNum = 1
RelNum  = 3
ModNum  = 1
RefrNum = 0

BackPath = 'BACKUP\'ptfnum'\'     /* Path to store back up files      */
SyseditDisk = DISK01              /* Disk label where sysedit.exe is  */

ZpFileName = 'CS2ZP'              /* Zip file name ex: cs2zp052.zip,  */
ZpEnding = '.ZIP'                 /* where '05' is option number and  */
                                  /* '2' is 3rd file for option 05.   */
MaxOptions = 34        /* possible install opts in netdist\mintopo.dat*/

/* Option 1 through 4 are used for other install info in NETDIST      */
FileInfo.5.0.diskNo = 1       /* #0 zip file for option 5 is on DISK01*/
FileInfo.5.1.diskNo = 2       /* #1 zip file for option 5 is on DISK02*/
FileInfo.5.topZip = 1         /* If 1, two zip files for option 5     */
FileInfo.5.reqSpace = 6342500 /* Total file space for option 5        */
FileInfo.6.reqSpace = 0       /* If 0, no zip files on PTF for opt 6  */
FileInfo.7.0.diskNo = 2
FileInfo.7.topZip = 0
FileInfo.7.reqSpace = 332000
FileInfo.8.0.diskNo = 3
FileInfo.8.topZip = 0
FileInfo.8.reqSpace = 737500
FileInfo.9.reqSpace = 0
FileInfo.10.0.diskNo = 3
FileInfo.10.topZip = 0
FileInfo.10.reqSpace = 1237000
FileInfo.11.reqSpace = 0
FileInfo.12.0.diskNo = 3
FileInfo.12.topZip = 0
FileInfo.12.reqSpace = 428000
FileInfo.13.reqSpace = 0
FileInfo.14.reqSpace = 0
FileInfo.15.reqSpace = 0
FileInfo.16.0.diskNo = 3
FileInfo.16.topZip = 0
FileInfo.16.reqSpace = 626000
FileInfo.17.reqSpace = 0
FileInfo.18.reqSpace = 0
FileInfo.19.0.diskNo = 3
FileInfo.19.topZip = 0
FileInfo.19.reqSpace = 699000
FileInfo.20.reqSpace = 0
FileInfo.21.0.diskNo = 4
FileInfo.21.1.diskNo = 5
FileInfo.21.topZip = 1
FileInfo.21.reqSpace = 4099500
FileInfo.22.reqSpace = 0
FileInfo.23.reqSpace = 0
FileInfo.24.reqSpace = 0
FileInfo.25.reqSpace = 0
FileInfo.26.reqSpace = 0
FileInfo.27.reqSpace = 0
FileInfo.28.reqSpace = 0
FileInfo.29.0.diskNo = 5
FileInfo.29.topZip = 0
FileInfo.29.reqSpace = 2265500
FileInfo.30.0.diskNo = 6
FileInfo.30.topZip = 0
FileInfo.30.reqSpace = 635000
FileInfo.31.reqSpace = 0
FileInfo.32.0.diskNo = 6
FileInfo.32.topZip = 0
FileInfo.32.reqSpace = 261500
FileInfo.33.0.diskNo = 6
FileInfo.33.topZip = 0
FileInfo.33.reqSpace = 308500
FileInfo.34.0.diskNo = 6
FileInfo.34.topZip = 0
FileInfo.34.reqSpace = 449500

/* Update above variables as necessary for development of PTF along   */
/* with updating CSD prev and current levels in Check_CSD routines    */

ReadFileName = ''
UpdateFileName = ''

/*--------------------------------------------------------------------*/
/*                       Start of main                                */
/*--------------------------------------------------------------------*/

SIGNAL ON HALT

parse arg target_drive

if target_drive = '' | target_drive = "?" then
  USAGE()

'@echo off'

source_drive = GetLoadDir()

source = TRANSLATE(SUBSTR(source_drive,1,1))':\'
target = TRANSLATE(SUBSTR(target_drive,1,1))':\CS2\'
target_root = TRANSLATE(SUBSTR(target_drive,1,1))':\'

CALL Verify_target target

sys      = target'SYS\'

/*
 * Installation flags
 */
InstallSys     = 0
CALL CheckDirs
if ( InstallSys \= 1 ) then USAGE()

say ''
say '**** CS/2 PTF 'ptfnum' Installation ****'

say ' '
say 'Checking the previous level of CS/2 ...'
say ' '

CALL Check_level target source

CALL InstallFiles source

If (ReinstFlag == NO) then
  CALL UpdateSyslevel

say ' '
say 'PTF 'ptfnum' Installed successfully.'
say ' '


exit


/*--------------------------------------------------------------------*/
/*                           Check Dirs                               */
/*--------------------------------------------------------------------*/
CheckDirs:
SaveDir = directory()
   TempDir = STRIP(sys,T,'\')
   if(directory(TempDir) <> '') then do
      InstallSys = 1

      end
   tmprc = directory(SaveDir)
return

/*--------------------------------------------------------------------*/
/*                           Verify target                            */
/*--------------------------------------------------------------------*/

Verify_target:
  parse arg target

  do forever
    temp_target = STRIP(target,T,'\')
    save_directory = directory()
    if(directory(temp_target) <> '') then do
      if(directory(save_directory) <> '') then
      target = temp_target'\'
      return
    end /* if */

    say 'The directory' temp_target 'does not exist.'
    say 'Please enter the source drive where CS/2 has been installed or ENTER',
        'to quit.'
    say ' '
    pull user_input
    if( user_input == '' ) then call Abnormal_exit
    target = TRANSLATE(STRIP(user_input,T,'\'))'\CS2'
  end /* do forever */

return

/*--------------------------------------------------------------------*/
/*                            Check level                             */
/*--------------------------------------------------------------------*/
Check_level:
parse arg target source
  if(stream(target'SYSLEVEL.CS2','c','query exists') <> '') then do
    sys_ext = 'CS2'
    call Check_syslevel sys_ext target source
    end /* if */
  else do
    Say 'Unable to locate' target'SYSLEVEL.CS2'
    Say 'Installation is unable to verify the level of CS/2 on the target'
    Say 'drive.'
    call AskAbortInstallation
  end
return



/*--------------------------------------------------------------------*/
/*                            Check Syslevel                          */
/*--------------------------------------------------------------------*/
Check_syslevel:
parse arg sys_ext target source

  SyslevelFileName = target'syslevel.'sys_ext
  ReadFileName = target'read.'sys_ext
  SyslevelVar. = ''
  PrevCSDLvl   = ''
  NumSysVar    = 0

   /*
    * If the read file exists then delete it
    */
    if (stream(ReadFileName,'c','query exists') <> '') then do
       "del " ReadFileName
       end
   /*
    * Read in the Syslevel file in the ReadFileName
    */
   CALL CheckDiskNumber target source syseditDisk
   source'sysedit ' SyslevelFileName  ReadFileName  'read'

   /*
    * Check to see if the read file name was created.  If it
    * was fill the compound variable with the name and the
    * values read from the syslevel file
    */
   NumSysVar = 0
   if (stream(ReadFileName,'c','query exists') <> '') then
      do while (lines(ReadFileName) \= 0)
         LineRead = linein(ReadFileName)
         Parse Var LineRead SyslevelVar.NumSysVar.Name . SyslevelVar.NumsysVar.Value
         NumSysVar = NumSysVar + 1
      end
   TotSysVar = NumSysVar
   /*
    * The criteria for the installation of this PTF is that the
    * target drive contains CS/2 release 1.3.1 installed and the
    * Current CSD is UN78045 or UN82709 or none.
    * Previous CSD is blanks or one of the above.
    */
   do j = 0 to (NumSysVar - 1)
      Select
             when (SyslevelVar.j.Name == "VERSION") then do
                  call CheckVersion SyslevelVar.j.Value
                  end
             when SyslevelVar.j.Name == 'RELEASE' then do
                  call CheckRelease SyslevelVar.j.Value
                  end
             when SyslevelVar.j.Name == 'MODIFICATION' then do
                  call CheckMod SyslevelVar.j.Value
                  end
             when SyslevelVar.j.Name == 'REFRESH' then do
                  call CheckRefresh SyslevelVar.j.Value
                  end
             when SyslevelVar.j.Name == 'CURRENT_CSD' then do
                  call CheckCurrentCSD SyslevelVar.j.Value
                  end
             when SyslevelVar.j.Name == 'PREVIOUS_CSD' then do
                  call CheckPreviousCSD SyslevelVar.j.Value
                  end
        otherwise Say ' Invalid Value in' ReadFileName SyslevelVar.j.Name
                  call Abnormal_Exit
      end /* end select */


   end  /* end the do loop */

   /*
    * If the read file exists then delete it
    */
    if (stream(ReadFileName,'c','query exists') <> '') then do
       Result = stream( ReadFileName, "C" , "Close" )
       "del "ReadFileName
       end

return


/*--------------------------------------------------------------------*/
/*                            Update Syslevel                         */
/*--------------------------------------------------------------------*/
UpdateSyslevel:

   UpdateFileName = target'write.'sys_ext

   /*
    * If the update file exists then delete it
    */
    if (stream(UpdateFileName,'c','query exists') <> '') then do
       "del " UpdateFileName
       end

   do j = 0 to (TotSysVar - 1)
      Select
             when SyslevelVar.j.Name == 'VERSION' then do
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
             when SyslevelVar.j.Name == 'RELEASE' then do
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
             when SyslevelVar.j.Name == 'MODIFICATION' then do
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
             when SyslevelVar.j.Name == 'REFRESH' then do
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
             when SyslevelVar.j.Name == 'CURRENT_CSD' then do
                  SyslevelVar.j.Value = '"'ptfnum'_"'
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
             when SyslevelVar.j.Name == 'PREVIOUS_CSD' then do
                  SyslevelVar.j.Value = PrevCSDLvl
                  TempVar = SyslevelVar.j.Name|| ' ' || '= ' ||SyslevelVar.j.Value
                  rc = lineout(UpdateFileName, TempVar)
                  end
        otherwise Say ' Invalid Value in' UpdateFileName SyslevelVar.j.Name
                  call Abnormal_Exit
      end /* end select */

   end  /* end the do loop */

   rc = lineout(UpdateFileName)

   /*
    * Write out the Syslevel file in the UpdateFileName
    */

   CALL CheckDiskNumber target source syseditDisk
   source'sysedit ' SyslevelFileName  UpdateFileName  'write'

   /*
    * If the update file exists then delete it
    */
    if (stream(UpdateFileName,'c','query exists') <> '') then do
       Result = stream( UpdateFileName, "C" , "Close" )
       "del "UpdateFileName
       end

return



/*--------------------------------------------------------------------*/
/*                      Install Files                                 */
/*--------------------------------------------------------------------*/
InstallFiles:
   parse arg source


   Repeat = 0

   SaveDir = directory()
   TempDir = STRIP(target,T,'\')
   Junk = directory(TempDir)

/*
 * Find out what options they have installed
 */
   NetdPath = value('CIFDM',,'OS2ENVIRONMENT')

   TopoFile = NetdPath'\mintopo.dat'  /* default */

   TempFile = NetdPath'\cifdm.prf'
   LineRead = ''
   NodeName = ''
   MastName = ''
   If (stream(TempFile,'c','query exists') <> '') then
        do while (lines(TempFile) \= 0)
             LineRead = linein(TempFile)
             Parse Var LineRead TempName .
             If (substr(TempName,1,9) == "NODENAME=") then do
               NodeName = substr(TempName,10)
               end
             If (substr(TempName,1,9) == "MASTNAME=") then do
               MastName = substr(TempName,10)
               end
        end /* while */
   If (NodeName == MastName) then
        TopoFile = NetdPath'\topology.dat'

   LineRead = ''
   FoundMinTopo = 0
   InstOpts = ''
   SaveExcess = ''

   If (stream(TopoFile,'c','query exists') <> '') then
        do while (lines(TopoFile) \= 0)
             LineRead = linein(TopoFile)
             Parse Var LineRead TempVar Excess
             If (substr(TempVar,1) == ("F6AC" || NodeName)) then
               SaveExcess = Excess
        end
   If (SaveExcess <> '') then
        do while (SaveExcess <> '')
             Parse Var SaveExcess InstOpts SaveExcess
        end

/*
 *  Check if mintopo.dat is found and valid
 */
   If ((InstOpts <> '') & (length(InstOpts) == MaxOptions)) then do
     If ((substr(InstOpts,1,1) == "Y") | (substr(InstOpts,1,1) == "N")) then
        FoundMinTopo = 1
     end

/*
 * Calculate minimum space needed for back-up of installed options
 */
   cntr = 5
   MinSpace = 0
   If (\FoundMinTopo) then
     InstOpts =     "YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY"  /* Default is all */
   do while (cntr <= MaxOptions)
       If (substr(InstOpts,cntr,1) == "Y") then do
         MinSpace = MinSpace + FileInfo.cntr.reqSpace
         end
       cntr = cntr + 1
   end
/*
 * Check for space
 */
   If \VerifySpace( target_drive, MinSpace )
         THEN DO
           Say 'There is not enough space available on the target drive.'
           Say 'Back up and install requires minimum 'MinSpace' bytes.'
           Say 'Make more space available, then restart the Install program.'
           Junk = directory(SaveDir)
           call Abnormal_Exit
         end

/*
 * Back up the old files
 */
   say
   say 'Backing Up Files...'
   say

   /* Back up syslevel.cs2.  But don't repeat in case they install again. */
   if (stream(target||BackPath'syslevel.bak','c','query exists') == '') then do
     'xcopy 'target'syslevel.cs2 ' target||BackPath ' > nul 2>&1'
     'rename 'target||BackPath'syslevel.cs2  syslevel.bak'
     end
   FileList = source||ptfnum'.lst'
   if (stream(FileList,'c','query exists') <> '') then
     do while (lines(FileList) \= 0)
       LineRead = linein(FileList)
       Parse Var LineRead Group FilePath FileName .
       If (substr(InstOpts,Group,1) == "Y") then do
         PathToCopyTo = target||BackPath||FilePath
         FileToCopy   = target||FilePath||FileName
         if (stream(PathToCopyTo||FileName,'c','query exists') == '') then do
           if (stream(FileToCopy,'c','query exists') <> '') then
             'xcopy 'FileToCopy PathToCopyTo' > nul 2>&1'
           end
         end
     end  /* do while */


/*
 * Unzip the files
 */
   say
   say 'Installing Files...'
   say

 'copy 'source'pkunzip.exe' target||BackPath
 'copy 'source||ptfnum'.DOC' target

 cntr = 5

 do while ( cntr <= MaxOptions )

   /*
    * Check for option installed and on PTF
    */
   If ( (substr(InstOpts,cntr,1) == 'Y') & (FileInfo.cntr.reqSpace \= 0) ) then do
      zipNum = 0
      do while (zipNum <= FileInfo.cntr.topZip)  /* some have mult zip files*/
        /*
         * Check the disk number
         */
        diskLabel = 'DISK0'FileInfo.cntr.zipNum.diskNo
        call CheckDiskNumber target source diskLabel

        /*
         * Unzip the file
         *        reminder: ZpFileName = 'CS2ZP' ,  ZpEnding = '.ZIP'
         */
        ZipFile = source||ZpFileName
        If (cntr < 10) then do
          ZipFile = ZipFile || '0'
          end
        ZipFile = ZipFile||cntr||zipNum||ZpEnding   /* EX: cs2zp050.zip */

        target||BackPath'pkunzip -o -d 'ZipFile /* directory() set target*/
        If (rc \= 0) & (rc \= 1) then do
          Say 'PKUNZIP failed, rc = 'rc'.'
          Say 'After resolving the error, rerun Install.'

          Junk = directory(SaveDir)
          call Abnormal_Exit
          end

        zipNum = zipNum + 1
      end /* end while more than one zip file for the option */

   end /* end if option installed and on ptf test */

   cntr = cntr + 1
 end /* do while for each option */

 'erase 'target||BackPath'pkunzip.exe'
 Junk = directory(SaveDir)

return

/*--------------------------------------------------------------------*/
/*                           Check Disk Number                        */
/*--------------------------------------------------------------------*/
CheckDiskNumber:
   parse arg target source DiskNumber
   source2 = STRIP( source, 'trailing' , "\" )
   do forever
       CorrectDisk = "NO"
       Call VerifyDiskette target source2 disknumber
       if CorrectDisk == "YES"
       THEN DO
         leave
       end
       else do
         Say 'Please insert diskette : ' DiskNumber
         Say 'Hit Enter to continue'
         pull .
       end
   end

return

/*--------------------------------------------------------------------*/
/*                           Check Version                            */
/*--------------------------------------------------------------------*/
CheckVersion:
parse arg Version

If (Version \= VersNum) then do
   Say 'Invalid Version in the Syslevel file : ' Version
   Say 'The PTF requires Version 'VersNum
   AskAbortInstallation
   end

return  /*** end check version  ***/

/*--------------------------------------------------------------------*/
/*                           Check Release                            */
/*--------------------------------------------------------------------*/
CheckRelease:
parse arg Release

If (Release \= RelNum) then do
   Say 'Invalid Release in the Syslevel file : ' Release
   Say 'The PTF requires Release 'RelNum
   call AskAbortInstallation
   end

return  /*** end check version  ***/

/*--------------------------------------------------------------------*/
/*                           Check Mod                                */
/*--------------------------------------------------------------------*/
CheckMod:
parse arg Mod

If (Mod \= ModNum) then do
   Say 'Invalid Modification level in the Syslevel file : ' Mod
   Say 'The PTF requires Modification level 'ModNum
   call AskAbortInstallation
   end

return  /*** end check version  ***/

/*--------------------------------------------------------------------*/
/*                           Check Refresh                            */
/*--------------------------------------------------------------------*/
CheckRefresh:
parse arg Refresh

If (Refresh \= RefrNum) then do
   Say 'Invalid Refresh level in the Syslevel file : ' Refresh
   Say 'The PTF requires Refresh level 'RefrNum
   call AskAbortInstallation
   end

return  /*** end check version  ***/

/*--------------------------------------------------------------------*/
/*                           Check Current CSD                        */
/*--------------------------------------------------------------------*/
CheckCurrentCSD:

parse arg CurrentCSD

PrevCSDLvl = CurrentCSD

If (CurrentCSD \= '"'prereq'_"' ) & ,
   (CurrentCSD \= '"'prerq1'_"' )  & ,
   (CurrentCSD \= '"'prerq2'_"' )  & ,
   (CurrentCSD \= '"        "' )  & ,
   (CurrentCSD \= '"'ptfnum'_"') then do   /* Can reinstall this PTF */
   Say 'Invalid Current CSD level in the Syslevel file : ' CurrentCSD
   Say 'The PTF is being installed at an incorrect CSD level'
   call AskAbortInstallation
   end

ReinstFlag = NO
If (CurrentCSD == '"'ptfnum'_"') then ReinstFlag = YES

return  /*** end check version  ***/

/*--------------------------------------------------------------------*/
/*                           Check Previous CSD                       */
/*--------------------------------------------------------------------*/
CheckPreviousCSD:
parse arg PreviousCSD

If (PreviousCSD \= '"'ptfnum'_"') & ,        /* Can install twice or  */
   (PreviousCSD \= '"'prereq'_"') & ,        /* Can install on top    */
   (PreviousCSD \= '"'prerq1'_"') & ,         /* Can install on top    */
   (PreviousCSD \= '"'prerq2'_"') & ,         /* Can install on top    */
   (PreviousCSD \= '"        "') then do
   Say 'Invalid Previous CSD level in the Syslevel file : ' PreviousCSD
   Say 'The PTF is being installed at an incorrect CSD level'
   call AskAbortInstallation
   end

return  /*** end check version  ***/


/*--------------------------------------------------------------------*/
/*                           Ask abort installation                   */
/*--------------------------------------------------------------------*/

AskAbortInstallation:
   Say 'Do you wish to abort installation (Y/N)?'
   pull Answer .
   if (Answer \= 'N') then do
      call Abnormal_exit
      end

return

/*--------------------------------------------------------------------*/
/*                           Abnormal exit                            */
/*--------------------------------------------------------------------*/

Abnormal_exit:

 /*
  * If the read or update file exists then delete it
  */
  if (ReadFileName \= '') then do
    if (stream(ReadFileName,'c','query exists') <> '') then do
       Result = stream( ReadFileName, "C" , "Close" )
       "del "ReadFileName
       end
  end

  if (UpdateFileName \= '') then do
    if (stream(UpdateFileName,'c','query exists') <> '') then do
       Result = stream( UpdateFileName, "C" , "Close" )
       "del "UpdateFileName
       end
  end

  say 'PTF installation exited abnormally.'

exit

/*--------------------------------------------------------------------*/
/*                           Control C                                */
/*--------------------------------------------------------------------*/

HALT:

  call Abnormal_exit

exit

/*--------------------------------------------------------------------*/
/*                               Usage                                */
/*--------------------------------------------------------------------*/

USAGE:
  say "**** CS/2 PTF Installation ****"
  say " "
  say "USAGE:"
  say "INSTALL <target_drive>"
  say
  say "<target_drive> should be the drive where CS/2 was installed."
  exit

/*--------------------------------------------------------------------*/
/*  GetLoadDir()                                                      */
/*                                                                    */
/*  Extract the name of the directory from which this module was      */
/*  loaded.                                                           */
/*--------------------------------------------------------------------*/
GetLoadDir: PROCEDURE

PARSE SOURCE "OS/2" "COMMAND" progname
loaddir = FILESPEC('drive', progname) || FILESPEC('path', progname)
loaddir = strip(loaddir)
loaddir = STRIP(loaddir, 'trailing', '\')

return loaddir

/*--------------------------------------------------------------------*/
/*  VerifyDiskette()                                                  */
/*                                                                    */
/*  Check for correct diskette.                                       */
/*--------------------------------------------------------------------*/
VerifyDiskette : procedure expose CorrectDisk

ARG target Drive Label
CorrectDisk = "NO"
Tempfile = target'Temp.out'
"VOL "Drive "> "TempFile "2>&1"
DO until \Lines( TempFile )
   Buffer = linein( TempFile )
   IF ( POS( Label , Buffer ) > 0 ) THEN CorrectDisk = "YES"
END
Result = stream( TempFile , "C" , "Close" )
"del "TempFile
return

/*--------------------------------------------------------------------*/
/* VerifySpace()                                                      */
/*--------------------------------------------------------------------*/
VerifySpace :
ARG Drive, Space
/* command to locate free space */
address cmd "@DIR "Drive"\*. /N | RXQUEUE /lifo 2>&1"
PARSE Version a b c d e .
IF ( e > 1991 )
THEN DO
   parse pull free type .
END
ELSE DO
   parse pull . . free .
   type = "B"
end  /* Do */
do queued()
   parse pull something
end /* do */
IF ( type == "K" )
then do
   free = free * 1000
end
IF free > Space THEN return 1
ELSE return 0
